use warnings;
use strict;
use Test::More tests => 3;
use Test::Exception;

use Time::HiRes qw( sleep );

use POWER::Event::Timer qw( :ALL );
use POWER::Utils;


my ($timer, $idle);

$timer = set_timer({ cb=>sub{}, for=>1 });

sleep 0.2;
$idle = get_timers_idle_time();
ok(0.7 < $idle && $idle < 0.8, '0.2 from 1 sec spent');

lives_ok { reset_timer($timer) } 'can reset timer';

$idle = get_timers_idle_time();
ok(0.9 < $idle && $idle < 1, '0.1 from 1 sec spent');

