use warnings;
use strict;
use Test::More tests => 5;
use Test::Exception;

use Time::HiRes qw( sleep );

use POWER::Event::Timer qw( :ALL );
use POWER::Utils;


package MyTimer;
our $Flag = 0;
sub ALARM { $Flag++ };

package main;
our $Flag = 0;
sub flag { $Flag++ }

sub loop {
    sleep get_timers_idle_time();
    defined $_->[0] && run_callback(@$_) for get_expired_timers();
}

is_deeply([$Flag, $MyTimer::Flag], [0, 0]);
{
    set_timer({ every => 0.1, cb => \&flag    });
    set_timer({ every => 0.1, cb => 'MyTimer' });
    my $obj = bless {}, 'MyTimer';
    set_timer({ every => 0.1, cb => $obj            });
    set_timer({ every => 0.1, cb => sub { $Flag++ } });
    # all 4 timers must work
    loop();
    is_deeply([$Flag, $MyTimer::Flag], [2, 2]);
    loop();
    is_deeply([$Flag, $MyTimer::Flag], [4, 4]);
}
# $obj must become destroyed, so only 3 timers will continue working...
loop();
is_deeply([$Flag, $MyTimer::Flag], [6, 5]);
loop();
is_deeply([$Flag, $MyTimer::Flag], [8, 6]);
